Index: /code/branches/core3/src/core/Factory.cc
===================================================================
--- /code/branches/core3/src/core/Factory.cc	(revision 1682)
+++ /code/branches/core3/src/core/Factory.cc	(revision 1683)
@@ -98,8 +98,4 @@
         }
         (*getFactoryPointer()->identifierStringMap_.begin()).second->stopCreatingHierarchy();
-/*
-        for (it = Identifier::getIdentifierMapIntern().begin(); it != Identifier::getIdentifierMapIntern().end(); ++it)
-            (*it).second->createSuperFunctionCaller();
-*/
         COUT(3) << "*** Factory: Finished class-hierarchy creation" << std::endl;
     }
Index: /code/branches/core3/src/core/Identifier.h
===================================================================
--- /code/branches/core3/src/core/Identifier.h	(revision 1682)
+++ /code/branches/core3/src/core/Identifier.h	(revision 1683)
@@ -315,11 +315,5 @@
 
             void updateConfigValues(bool updateChildren = true) const;
-/*
-            XMLPortParamContainer* getXMLPortParamContainer(const std::string& paramname);
-            void addXMLPortParamContainer(const std::string& paramname, XMLPortParamContainer* container);
-
-            XMLPortObjectContainer* getXMLPortObjectContainer(const std::string& sectionname);
-            void addXMLPortObjectContainer(const std::string& sectionname, XMLPortObjectContainer* container);
-*/
+
         private:
             ClassIdentifier(const ClassIdentifier<T>& identifier) {}    // don't copy
@@ -333,15 +327,6 @@
                 #define SUPER_INTRUSIVE_DESTRUCTOR
                 #include "Super.h"
-/*
-                for (std::map<std::string, XMLPortParamContainer*>::iterator it = this->xmlportParamContainers_.begin(); it != this->xmlportParamContainers_.end(); ++it)
-                    delete (it->second);
-                for (std::map<std::string, XMLPortObjectContainer*>::iterator it = this->xmlportObjectContainers_.begin(); it != this->xmlportObjectContainers_.end(); ++it)
-                    delete (it->second);
-*/
-            }
-/*
-            std::map<std::string, XMLPortClassParamContainer<class O>*> xmlportParamContainers_;              //!< All loadable parameters
-            std::map<std::string, XMLPortClassObjectContainer<T, class O>*> xmlportObjectContainers_;   //!< All attachable objects
-*/
+            }
+
             static ClassIdentifier<T> *classIdentifier_s;
     };
@@ -463,56 +448,4 @@
                 (*it)->updateConfigValues(false);
     }
-
-    /**
-        @brief Returns a XMLPortParamContainer that loads a parameter of this class.
-        @param paramname The name of the parameter
-        @return The container
-    *//*
-    template <class T>
-    XMLPortParamContainer* ClassIdentifier<T>::getXMLPortParamContainer(const std::string& paramname)
-    {
-        typename std::map<std::string, XMLPortClassParamContainer<class O>*>::const_iterator it = xmlportParamContainers_.find(paramname);
-        if (it != xmlportParamContainers_.end())
-            return (XMLPortParamContainer*)((*it).second);
-        else
-            return 0;
-    }*/
-
-    /**
-        @brief Adds a new XMLPortParamContainer that loads a parameter of this class.
-        @param paramname The name of the parameter
-        @param container The container
-    *//*
-    template <class T>
-    void ClassIdentifier<T>::addXMLPortParamContainer(const std::string& paramname, XMLPortParamContainer* container)
-    {
-        this->xmlportParamContainers_[paramname] = (XMLPortClassParamContainer<class O>*)container;
-    }*/
-
-    /**
-        @brief Returns a XMLPortObjectContainer that attaches an object to this class.
-        @param sectionname The name of the section that contains the attachable objects
-        @return The container
-    *//*
-    template <class T>
-    XMLPortObjectContainer* ClassIdentifier<T>::getXMLPortObjectContainer(const std::string& sectionname)
-    {
-        typename std::map<std::string, XMLPortClassObjectContainer<T, class O>*>::const_iterator it = xmlportObjectContainers_.find(sectionname);
-        if (it != xmlportObjectContainers_.end())
-            return (XMLPortObjectContainer*)((*it).second);
-        else
-            return 0;
-    }*/
-
-    /**
-        @brief Adds a new XMLPortObjectContainer that attaches an object to this class.
-        @param sectionname The name of the section that contains the attachable objects
-        @param container The container
-    *//*
-    template <class T>
-    void ClassIdentifier<T>::addXMLPortObjectContainer(const std::string& sectionname, XMLPortObjectContainer* container)
-    {
-        this->xmlportObjectContainers_[sectionname] = (XMLPortClassObjectContainer<T, class O>*)container;
-    }*/
 
 
Index: /code/branches/core3/src/core/Super.h
===================================================================
--- /code/branches/core3/src/core/Super.h	(revision 1682)
+++ /code/branches/core3/src/core/Super.h	(revision 1683)
@@ -107,5 +107,4 @@
     }
 
-
 ////////////////////////////
 // Function-specific code //
Index: /code/branches/core3/src/orxonox/objects/Projectile.h
===================================================================
--- /code/branches/core3/src/orxonox/objects/Projectile.h	(revision 1682)
+++ /code/branches/core3/src/orxonox/objects/Projectile.h	(revision 1683)
@@ -97,14 +97,4 @@
             ClassIdentifier<T>* identifier = ClassIdentifier<T>::getIdentifier();
 
-/*
-            SuperFunctionCaller_testfunction* superFunctionCaller = 0;
-            // Search for an existing caller within all direct children
-            for (std::set<const Identifier*>::iterator it = identifier->getDirectChildrenIntern().begin(); it != identifier->getDirectChildrenIntern().end(); ++it)
-                if (((ClassIdentifier<T>*)(*it))->superFunctionCaller_testfunction_)
-                    superFunctionCaller = ((ClassIdentifier<T>*)(*it))->superFunctionCaller_testfunction_;
-            // Check if we've found an existing caller - if not, create a new one
-            if (!superFunctionCaller)
-                superFunctionCaller = new SuperFunctionClassCaller_testfunction<T>;
-*/
             // Iterate through all children and assign the caller
             for (std::set<const Identifier*>::iterator it = identifier->getDirectChildrenIntern().begin(); it != identifier->getDirectChildrenIntern().end(); ++it)
@@ -113,5 +103,4 @@
                 {
                     std::cout << "adding functionpointer to " << ((ClassIdentifier<T>*)(*it))->getName() << std::endl;
-//                    ((ClassIdentifier<T>*)(*it))->superFunctionCaller_testfunction_ = superFunctionCaller;
                     ((ClassIdentifier<T>*)(*it))->superFunctionCaller_testfunction_ = new SuperFunctionClassCaller_testfunction<T>;
                 }