Index: /code/branches/core3/src/core/Identifier.h
===================================================================
--- /code/branches/core3/src/core/Identifier.h	(revision 1684)
+++ /code/branches/core3/src/core/Identifier.h	(revision 1685)
@@ -62,5 +62,4 @@
 #include "MetaObjectList.h"
 #include "Iterator.h"
-#undef SUPER_INTRUSIVE
 #include "Super.h"
 #include "util/Debug.h"
Index: /code/branches/core3/src/core/Super.h
===================================================================
--- /code/branches/core3/src/core/Super.h	(revision 1684)
+++ /code/branches/core3/src/core/Super.h	(revision 1685)
@@ -251,7 +251,4 @@
     //// Common code ////
 
-        // Dummy - only needed to cast Identifier* to ClassIdentifier<SuperDummy>* (the real class doesn't matter)
-        class SuperDummy {};
-
         // Base template
         template <int functionnumber, class T, int templatehack1, int templatehack2>
Index: /code/branches/core3/src/orxonox/objects/BillboardProjectile.cc
===================================================================
--- /code/branches/core3/src/orxonox/objects/BillboardProjectile.cc	(revision 1684)
+++ /code/branches/core3/src/orxonox/objects/BillboardProjectile.cc	(revision 1685)
@@ -48,8 +48,9 @@
             this->scale(0.5);
         }
-
+/*
         std::cout << "a:\n";
         SUPER(BillboardProjectile, testfunction);
         std::cout << "b:\n";
+*/
     }
 
Index: /code/branches/core3/src/orxonox/objects/BillboardProjectile.h
===================================================================
--- /code/branches/core3/src/orxonox/objects/BillboardProjectile.h	(revision 1684)
+++ /code/branches/core3/src/orxonox/objects/BillboardProjectile.h	(revision 1685)
@@ -38,47 +38,5 @@
 namespace orxonox
 {
-    class TESTTESTTEST1
-    {
-        public:
-            TESTTESTTEST1() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            Identifier* identifier_;
-    };
-
-    class TESTTESTTEST2
-    {
-        public:
-            TESTTESTTEST2() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            double value3_;
-            char value4_;
-            bool value5_;
-            Identifier* identifier1_;
-            Identifier* identifier2_;
-    };
-
-    class TESTTESTTEST3 : virtual public TESTTESTTEST1
-    {
-        public:
-            TESTTESTTEST3() { this->setMyOtherValue(10); }
-
-        private:
-            void setMyOtherValue(int value) { this->value3_ = value; }
-
-            int value3_;
-            TESTTESTTEST2* test_;
-    };
-
-    class _OrxonoxExport BillboardProjectile : public Projectile, public TESTTESTTEST3, public TESTTESTTEST2, virtual public TESTTESTTEST1
+    class _OrxonoxExport BillboardProjectile : public Projectile
     {
         public:
Index: /code/branches/core3/src/orxonox/objects/ParticleProjectile.cc
===================================================================
--- /code/branches/core3/src/orxonox/objects/ParticleProjectile.cc	(revision 1684)
+++ /code/branches/core3/src/orxonox/objects/ParticleProjectile.cc	(revision 1685)
@@ -55,5 +55,5 @@
 
         this->setConfigValues();
-
+/*
         std::cout << "c:\n";
         SUPER(ParticleProjectile, testfunction);
@@ -63,4 +63,5 @@
         this->testfunction();
         std::cout << "f:\n";
+*/
     }
 
Index: /code/branches/core3/src/orxonox/objects/ParticleProjectile.h
===================================================================
--- /code/branches/core3/src/orxonox/objects/ParticleProjectile.h	(revision 1684)
+++ /code/branches/core3/src/orxonox/objects/ParticleProjectile.h	(revision 1685)
@@ -38,47 +38,5 @@
 namespace orxonox
 {
-    class TESTTESTTEST13
-    {
-        public:
-            TESTTESTTEST13() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            Identifier* identifier_;
-    };
-
-    class TESTTESTTEST23
-    {
-        public:
-            TESTTESTTEST23() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            double value3_;
-            char value4_;
-            bool value5_;
-            Identifier* identifier1_;
-            Identifier* identifier2_;
-    };
-
-    class TESTTESTTEST33 : virtual public TESTTESTTEST13
-    {
-        public:
-            TESTTESTTEST33() { this->setMyOtherValue(10); }
-
-        private:
-            void setMyOtherValue(int value) { this->value3_ = value; }
-
-            int value3_;
-            TESTTESTTEST23* test_;
-    };
-
-    class _OrxonoxExport ParticleProjectile : public TESTTESTTEST33, public BillboardProjectile, virtual public TESTTESTTEST13
+    class _OrxonoxExport ParticleProjectile : public BillboardProjectile
     {
         public:
Index: /code/branches/core3/src/orxonox/objects/Projectile.h
===================================================================
--- /code/branches/core3/src/orxonox/objects/Projectile.h	(revision 1684)
+++ /code/branches/core3/src/orxonox/objects/Projectile.h	(revision 1685)
@@ -38,47 +38,5 @@
 namespace orxonox
 {
-    class TESTTESTTEST12
-    {
-        public:
-            TESTTESTTEST12() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            Identifier* identifier_;
-    };
-
-    class TESTTESTTEST22
-    {
-        public:
-            TESTTESTTEST22() { this->setMyValue(10); }
-
-        private:
-            void setMyValue(int value) { this->value1_ = value; }
-
-            int value1_;
-            int value2_;
-            double value3_;
-            char value4_;
-            bool value5_;
-            Identifier* identifier1_;
-            Identifier* identifier2_;
-    };
-
-    class TESTTESTTEST32 : virtual public TESTTESTTEST12
-    {
-        public:
-            TESTTESTTEST32() { this->setMyOtherValue(10); }
-
-        private:
-            void setMyOtherValue(int value) { this->value3_ = value; }
-
-            int value3_;
-            TESTTESTTEST22* test_;
-    };
-
-    class _OrxonoxExport Projectile : public TESTTESTTEST22, public TESTTESTTEST32, virtual public TESTTESTTEST12, public WorldEntity
+    class _OrxonoxExport Projectile : public WorldEntity
     {
         public: